<?php

class module_global_article extends module_global {

	protected $_sModulePath = 'global/article';

	public function getView($sView_) {
		return new _view($this->_sModulePath . '::' . $sView_);
	}

	public function _index() {
		//on considere que la page par defaut est la page de listage
		$this->_list();
	}

	public function _list() {

		$tArticle = model_article::getInstance()->findAll();

		$oView = $this->getView('list');
		$oView->tArticle = $tArticle;

		

		$this->oLayout->add('main', $oView);
	}

	public function _new() {
		$tMessage = $this->processSave();

		$oArticle = new row_article;

		$oView = $this->getView('new');
		$oView->oArticle = $oArticle;

		

		$oPluginXsrf = new plugin_xsrf();
		$oView->token = $oPluginXsrf->getToken();
		$oView->tMessage = $tMessage;

		$this->oLayout->add('main', $oView);
	}

	public function _edit() {
		$tMessage = $this->processSave();

		$oArticle = model_article::getInstance()->findById(_root::getParam('id'));

		$oView = $this->getView('edit');
		$oView->oArticle = $oArticle;

		

		$oPluginXsrf = new plugin_xsrf();
		$oView->token = $oPluginXsrf->getToken();
		$oView->tMessage = $tMessage;

		$this->oLayout->add('main', $oView);
	}

	public function _show() {
		$oArticle = model_article::getInstance()->findById(_root::getParam('id'));

		$oView = $this->getView('show');
		$oView->oArticle = $oArticle;

		


		$this->oLayout->add('main', $oView);
	}

	public function _delete() {
		$tMessage = $this->processDelete();

		$oArticle = model_article::getInstance()->findById(_root::getParam('id'));

		$oView = $this->getView('delete');
		$oView->oArticle = $oArticle;

		


		$oPluginXsrf = new plugin_xsrf();
		$oView->token = $oPluginXsrf->getToken();
		$oView->tMessage = $tMessage;

		$this->oLayout->add('main', $oView);
	}

	private function processSave() {
		if (!_root::getRequest()->isPost()) { //si ce n'est pas une requete POST on ne soumet pas
			return null;
		}

		$oPluginXsrf = new plugin_xsrf();
		if (!$oPluginXsrf->checkToken(_root::getParam('token'))) { //on verifie que le token est valide
			return array('token' => $oPluginXsrf->getMessage());
		}

		$tParams = _root::getRequest()->getParams();

		$oBusiness = new business_crudArticle(model_article::getInstance(), _root::getI18n(), new plugin_sc_valid() );

		$iId = _root::getParam('id', null);
		if ($iId == null) {
			if (false === $oBusiness->insertItem(new row_article, $tParams)) {
				return $oBusiness->getReturn()->getData('tError');
			}
		} else {
			if (false === $oBusiness->updateItem(_root::getParam('id'), $tParams)) {
				return $oBusiness->getReturn()->getData('tError');
			}
		}


		//une fois enregistre on redirige (vers la page liste)
		_root::redirect('global_article::list');
	}

	public function processDelete() {
		if (!_root::getRequest()->isPost()) { //si ce n'est pas une requete POST on ne soumet pas
			return null;
		}

		$oPluginXsrf = new plugin_xsrf();
		if (!$oPluginXsrf->checkToken(_root::getParam('token'))) { //on verifie que le token est valide
			return array('token' => $oPluginXsrf->getMessage());
		}

		$oBusiness = new business_crudArticle(model_article::getInstance(), _root::getI18n(), new plugin_sc_valid()  );

		$oArticle = model_article::getInstance()->findById(_root::getParam('id'));

		if (false === $oBusiness->deleteItem($oArticle)) {
			return $oBusiness->getReturn()->getData('tError');
		}

		//une fois supprime on redirige (vers la page liste)
		_root::redirect('global_article::list');
	}

}
