<?php

require_once(__DIR__ . '/../autoload_unitaire.php');

if (!function_exists('tr')) {

	function tr($sTag) {
		return $sTag;
	}

}

/**
 * @runTestsInSeparateProcesses
 * @preserveGlobalState disabled
 */
class module_global_articleTest extends PHPUnit_Framework_TestCase {

	public function run(PHPUnit_Framework_TestResult $result = NULL) {
		$this->setPreserveGlobalState(false);
		return parent::run($result);
	}

	public function test_newShoulFinishOk() {

		$tColumn = array(	'titre',	'auteur',	'date',);

		//arrange
		$_SERVER['REQUEST_METHOD'] = 'GET';
		_root::addRequest(array());
		_root::loadRequest();

		//act
		$oArticle = new stdclass;
		foreach ($tColumn as $sColumn) {
			$oArticle->$sColumn = 'value' . $sColumn . 'value';
		}

		$oModule = new module_global_article;

		$oView = $oModule->getView('new');
		$oView->oArticle = $oArticle;
		$oView->tMessage = array();
		$oView->token = null;

		$sView = $oView->show();

		//assert

		foreach ($tColumn as $sColumn) {
			$this->assertRegExp('/name="' . $sColumn . '"/', $sView);
		}
	}

	public function test_editShoulFinishOk() {

		$tColumn = array(	'titre',	'auteur',	'date',);

		//arrange
		$_SERVER['REQUEST_METHOD'] = 'GET';
		_root::addRequest(array());
		_root::loadRequest();

		//act
		$oArticle = new stdclass;
		foreach ($tColumn as $sColumn) {
			$oArticle->$sColumn = 'value' . $sColumn . 'value';
		}

		$oModule = new module_global_article;

		$oView = $oModule->getView('edit');
		$oView->oArticle = $oArticle;
		$oView->tMessage = array();
		$oView->token = null;

		$sView = $oView->show();

		//assert

		foreach ($tColumn as $sColumn) {
			$this->assertRegExp('/name="' . $sColumn . '"/', $sView);
			$this->assertRegExp('/value' . $sColumn . '/', $sView);
		}
	}

	public function test_showShoulFinishOk() {

		$tColumn = array(	'titre',	'auteur',	'date',);

		//arrange
		$_SERVER['REQUEST_METHOD'] = 'GET';
		_root::addRequest(array());
		_root::loadRequest();

		//act
		$oArticle = new stdclass;
		foreach ($tColumn as $sColumn) {
			$oArticle->$sColumn = 'value' . $sColumn . 'value';
		}

		$oModule = new module_global_article;

		$oView = $oModule->getView('show');
		$oView->oArticle = $oArticle;

		$sView = $oView->show();

		//assert

		foreach ($tColumn as $sColumn) {
			$this->assertRegExp('/' . $sColumn . '/', $sView);
			$this->assertRegExp('/value' . $sColumn . '/', $sView);
		}
	}

	public function test_listShoulFinishOk() {

		$tColumn = array(	'titre',	'auteur',	'date',);

		//arrange
		$_SERVER['REQUEST_METHOD'] = 'GET';
		_root::addRequest(array());
		_root::loadRequest();

		//act
		$tArticle = array();
		for ($i = 0; $i < 4; $i++) {

			$oArticle = new stdclass;
			foreach ($tColumn as $sColumn) {
				$oArticle->$sColumn = 'value' . $i . $sColumn . 'value' . $i;
			}
			$oArticle->id = $i;
			$tArticle[] = $oArticle;
		}

		$oModule = new module_global_article;

		$oView = $oModule->getView('list');
		$oView->tArticle = $tArticle;

		$sView = $oView->show();

		//assert
		foreach ($tColumn as $sColumn) {
			$this->assertRegExp('/' . $sColumn . '/', $sView);
		}

		for ($i = 0; $i < 4; $i++) {
			foreach ($tColumn as $sColumn) {
				$this->assertRegExp('/value' . $i . $sColumn . 'value' . $i . '/', $sView);
			}
		}
	}

}
